var RouteLoader = require("./RouteLoader").RouteLoader;


class Request {
    constructor(data, routeOptions) {
        this.routeOptions = routeOptions;

        this.route = {
            name: data.name,
            action: data.action,
            params: data.params
        };

        this.options = data.options;
    }

    getRoute() {
        const loader = new RouteLoader(this.routeOptions);
        return loader.find(this.route)
    };

    resetRequest() {
        this.params = [];
        this.options = {};
        this.name = "";
        this.action = "";
    }

    send() {
        return this.getRoute()
            .then(async url => {
                const response = await fetch(url, this.options);
                this.resetRequest();
                return await response.json();
            })
    }

}

module.exports.Request = Request;
